/* Startup code for statically linked root server.
   Copyright (C) 2003 Free Software Foundation, Inc.
   This file is part of the GNU Hurd.

   The GNU Hurd is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU Hurd is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307 USA.  */

	/* Beginning of the text segment, which must start with _start.  */
	.text
	.globl _start
_start:
	/* Clear the frame pointer.  The ABI suggests this be done, to mark
	   the outermost frame obviously.  */
	xorl %ebp, %ebp

	/* Load the ESP register with the small stack below.  */
	leal __stack, %esp

	/* Push the multiboot header address on the stack.  */
	pushl %ebx

	/* Push the multiboot magic on the stack.  */
	pushl %eax

	/* Call the main function.  */
	call main

	/* Shutdown.  */
	pushl %eax
	pushl $halt_message
	call printf

loop:	jmp loop

halt_message:
	.asciz "Exit code: 0x%x.  System halted."


	/* The multiboot header follows.  It must be within the first
	8192 bytes of the binary image, and longword aligned.  */
	.align 4
__mb_header:
	/* The magic.  */
	.long 0x1BADB002;
	/* The flags.  */
	.long 0x00000000;
	/* The checksum (must add to zero with the magic and flags.  */
	.long -0x1BADB002;
	

	/* Beginning of the bss segment.  */
	.bss

	/* The stack space.  */
	.space	0x1000
__stack:
